#include "links.h"

/*void root_handler(struct window *win, struct event *ev, int fwd)
{
	printf("%d %d %d\n", ev->ev, ev->x, ev->y);
	fill_area(win->term, 1, 2, 3, 4, '+' | 0x0f00);
}*/

int attach_terminal(int in, int out, void *info, int len)
{
	int fd[2];
	if (c_pipe(fd)) {
		mem_free(info);
		error("ERROR: can't create pipe for internal communication");
		return -1;
	}
	handle_trm(in, out, out, fd[1], info, len);
	mem_free(info);
	init_term(fd[0], out, win_func);
	return fd[1];
}

int ac;
unsigned char **av;

unsigned char *path_to_exe;

void init()
{
	void *info;
	int len;
	unsigned char *u;
	set_sigcld();
	init_home();
	load_config();
	u = parse_options(ac - 1, av + 1);
	if (!u) {
		terminate = 1;
		return;
	}
	if ((info = create_session_info(0, u, &len))) attach_terminal(get_input_handle(), 1, info, len);
	else terminate = 1;
}

void terminate_all_subsystems()
{
	destroy_all_sessions();
	abort_all_downloads();
	destroy_all_terminals();
	check_bottom_halves();
	free_all_itrms();
	abort_all_connections();
	shrink_memory(1);
	free_history_lists();
	free_term_specs();
	free_types();
	free_conv_table();
	free_blacklist();
	check_bottom_halves();
	end_config();
}

int main(int argc, char *argv[])
{
	path_to_exe = argv[0];
	ac = argc;
	av = (unsigned char **)argv;
	select_loop(init);
	terminate_all_subsystems();

	check_memory_leaks();
	return 0;
}

void shrink_memory(int u)
{
	shrink_dns_cache(u);
	shrink_format_cache(u);
	garbage_collection(u);
	delete_unused_format_cache_entries();
}
